#include "Stickc.h"

void STICKC::begin(bool LCDEnable, bool PowerEnable, bool SerialEnable){
	M5.begin(LCDEnable, PowerEnable, SerialEnable);
	digitalWrite(10, HIGH);
	pinMode(10, OUTPUT);
}

void STICKC::update(void){
	M5.update();
}

void STICKC::drawPixel(int32_t x, int32_t y, uint32_t color){
	M5.Lcd.drawPixel(x, y, color);
}

void STICKC::fillScreen(uint32_t color){
	M5.Lcd.fillScreen(color);
}

int16_t STICKC::height(void){
	return M5.Lcd.height();
}

int16_t STICKC::width(void){
	return M5.Lcd.width();
}

void STICKC::setRotation(uint8_t r){
	M5.Lcd.setRotation(r);
}

void STICKC::drawLine(int32_t x0, int32_t y0, int32_t x1, int32_t y1, uint32_t color){
	M5.Lcd.drawLine(x0, y0, x1, y1, color);
}

void STICKC::fillRect(int32_t x, int32_t y, int32_t w, int32_t h, uint32_t color){
	M5.Lcd.fillRect(x, y, w, h, color);
}

void STICKC::drawRect(int32_t x, int32_t y, int32_t w, int32_t h, uint32_t color){
	M5.Lcd.drawRect(x, y, w, h, color);
}

void STICKC::drawRoundRect(int32_t x0, int32_t y0, int32_t w, int32_t h, int32_t radius, uint32_t color){
	M5.Lcd.drawRoundRect(x0, y0, w, h, radius, color);
}

void STICKC::fillRoundRect(int32_t x0, int32_t y0, int32_t w, int32_t h, int32_t radius, uint32_t color){
	M5.Lcd.fillRoundRect(x0, y0, w, h, radius, color);
}

void STICKC::drawCircle(int32_t x0, int32_t y0, int32_t r, uint32_t color){
	M5.Lcd.drawCircle(x0, y0, r, color);
}

void STICKC::fillCircle(int32_t x0, int32_t y0, int32_t r, uint32_t color){
	M5.Lcd.fillCircle(x0, y0, r, color);
}

void STICKC::drawEllipse(int16_t x0, int16_t y0, int32_t rx, int32_t ry, uint16_t color){
	M5.Lcd.drawEllipse(x0, y0, rx, ry, color);
}

void STICKC::fillEllipse(int16_t x0, int16_t y0, int32_t rx, int32_t ry, uint16_t color){
	M5.Lcd.fillEllipse(x0, y0, rx, ry, color);
}

void STICKC::drawTriangle(int32_t x0, int32_t y0, int32_t x1, int32_t y1, int32_t x2, int32_t y2, uint32_t color){
	M5.Lcd.drawTriangle(x0, y0, x1, y1, x2, y2, color);
}

void STICKC::fillTriangle(int32_t x0, int32_t y0, int32_t x1, int32_t y1, int32_t x2, int32_t y2, uint32_t color){
	M5.Lcd.fillTriangle(x0, y0, x1, y1, x2, y2, color);
}

void STICKC::setCursor(int16_t x, int16_t y){
	M5.Lcd.setCursor(x, y);
}

void STICKC::setTextColor(uint16_t fgcolor, uint16_t bgcolor){
	M5.Lcd.setTextColor(fgcolor, bgcolor);
}

void STICKC::setTextSize(uint8_t size){
	M5.Lcd.setTextSize(size);
}

void STICKC::setTextFont(uint8_t font){
	M5.Lcd.setTextFont(font);
}

uint16_t STICKC::color565(uint8_t red, uint8_t green, uint8_t blue){
	M5.Lcd.color565(red, green, blue);
}

void STICKC::printp(const char* str){
	M5.Lcd.println(str);
}

void STICKC::drawString(const char *string, int32_t poX, int32_t poY){
	M5.Lcd.drawString(string, poX, poY);
}

void STICKC::backlit(uint8_t brightness){
	M5.axp.ScreenBreath(brightness);
}
void STICKC::AXP_DisableAllIRQ(void){
	M5.axp.DisableAllIRQ();
}
void STICKC::AXP_ClearAllIRQ(void){
	M5.axp.ClearAllIRQ();
}
void STICKC::AXP_EnablePressIRQ(bool short_press, bool long_press){
	M5.axp.EnablePressIRQ(short_press, long_press);
}
void STICKC::AXP_GetPressIRQ(bool *short_press, bool *long_press){
	M5.axp.GetPressIRQ(short_press, long_press);
}
void STICKC::AXP_ClearPressIRQ(bool short_press, bool long_press){
	M5.axp.ClearPressIRQ(short_press, long_press);
}
void STICKC::AXP_SetSleep(void){
	M5.axp.SetSleep();
}
void STICKC::AXP_DeepSleep(uint64_t time_in_us){
	M5.axp.DeepSleep(time_in_us);
}
void STICKC::AXP_LightSleep(uint64_t time_in_us){
	M5.axp.LightSleep(time_in_us = 0);
}
void STICKC::AXP_SetChargeVoltage(uint8_t V){
	M5.axp.SetChargeVoltage(V);
}
void STICKC::AXP_SetChargeCurrent(uint8_t C){
	M5.axp.SetChargeCurrent(C);
}
void STICKC::AXP_SetVOff(uint8_t voltage){
	M5.axp.SetVOff(voltage);
}
float STICKC::AXP_GetBatVoltage(){
	return M5.axp.GetBatVoltage();
}
float STICKC::AXP_GetBatCurrent(){
	return M5.axp.GetBatCurrent();
}
float STICKC::AXP_GetVinVoltage(){
	return M5.axp.GetVinVoltage();
}
float STICKC::AXP_GetVinCurrent(){
	return M5.axp.GetVinCurrent();
}
float STICKC::AXP_GetVBusVoltage(){
	return M5.axp.GetVBusVoltage();
}
float STICKC::AXP_GetVBusCurrent(){
	return M5.axp.GetVBusCurrent();
}
float STICKC::AXP_GetBatPower(){
	return M5.axp.GetBatPower();
}
void STICKC::PowerOff(){
	M5.axp.PowerOff();
}

void STICKC::LED_On(){
	digitalWrite(10, LOW);
}
void STICKC::LED_Off(){
	digitalWrite(10, HIGH);
}
uint8_t STICKC::LED_getStatus(){
	return digitalRead(10);
}

int STICKC::IMU_Init(void){
	return M5.imu.Init();
}
void STICKC::IMU_getAccelAdc(int16_t *ax, int16_t *ay, int16_t *az){
	M5.imu.getAccelAdc(ax, ay, az);
}
void STICKC::IMU_getGyroAdc(int16_t *gx, int16_t *gy, int16_t *gz){
	M5.imu.getGyroAdc(gx, gy, gz);
}
void STICKC::IMU_getTempAdc(int16_t *t){
	M5.imu.getTempAdc(t);
}
void STICKC::IMU_getAccelData(float *ax, float *ay, float *az){
	M5.imu.getAccelData(ax, ay, az);
}
void STICKC::IMU_getGyroData(float *gx, float *gy, float *gz){
	M5.imu.getGyroData(gx, gy, gz);
}
void STICKC::IMU_getTempData(float *t){
	M5.imu.getTempData(t);
}
void STICKC::IMU_getAhrsData(float *pitch, float *roll, float *yaw){
	M5.imu.getAhrsData(pitch, roll, yaw);
}

void STICKC::RTC_SetTime(uint8_t Hours, uint8_t Minutes, uint8_t Seconds){
	RTC_TimeTypeDef t;
	t.Hours = Hours;
	t.Minutes = Minutes;
	t.Seconds = Seconds;
	M5.Rtc.SetTime(&t);
}
void STICKC::RTC_SetDate(uint8_t WeekDay, uint8_t Month, uint8_t Date, uint16_t Year){
	RTC_DateTypeDef d;
	d.WeekDay = WeekDay;
	d.Month = Month;
	d.Date = Date;
	d.Year = Year;
	M5.Rtc.SetData(&d);
}
void STICKC::RTC_GetTime(uint8_t *Hours, uint8_t *Minutes, uint8_t *Seconds){
	RTC_TimeTypeDef t;
	M5.Rtc.GetTime(&t);
	*Hours=t.Hours;
	*Minutes=t.Minutes;
	*Seconds=t.Seconds;
}
void STICKC::RTC_GetDate(uint8_t *WeekDay, uint8_t *Month, uint8_t *Date, uint16_t *Year){
	RTC_DateTypeDef d;
	M5.Rtc.GetData(&d);
	*WeekDay = d.WeekDay;
	*Month = d.Month;
	*Date = d.Date;
	*Year = d.Year;
}

uint8_t STICKC::BtnA_isPressed(){
	return M5.BtnA.isPressed();
}
uint8_t STICKC::BtnA_isReleased(){
	return M5.BtnA.isReleased();
}
uint8_t STICKC::BtnA_wasPressed(){
	return M5.BtnA.wasPressed();
}
uint8_t STICKC::BtnA_wasReleased(){
	return M5.BtnA.wasReleased();
}
uint8_t STICKC::BtnA_pressedFor(uint32_t ms){
	return M5.BtnA.pressedFor(ms);
}
uint8_t STICKC::BtnA_releasedFor(uint32_t ms){
	return M5.BtnA.releasedFor(ms);
}
uint8_t STICKC::BtnA_wasReleasefor(uint32_t ms){
	return M5.BtnA.wasReleasefor(ms);
}
uint8_t STICKC::BtnB_isPressed(){
	return M5.BtnB.isPressed();
}
uint8_t STICKC::BtnB_isReleased(){
	return M5.BtnB.isReleased();
}
uint8_t STICKC::BtnB_wasPressed(){
	return M5.BtnB.wasPressed();
}
uint8_t STICKC::BtnB_wasReleased(){
	return M5.BtnB.wasReleased();
}
uint8_t STICKC::BtnB_pressedFor(uint32_t ms){
	return M5.BtnB.pressedFor(ms);
}
uint8_t STICKC::BtnB_releasedFor(uint32_t ms){
	return M5.BtnB.releasedFor(ms);
}
uint8_t STICKC::BtnB_wasReleasefor(uint32_t ms){
	return M5.BtnB.wasReleasefor(ms);
}